unit icono;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, LResources, Forms, Controls, Graphics, Dialogs, ExtCtrls;

type

  { TfrmIcono }

  TfrmIcono = class(TForm)
    imgIcono: TImage;
    imlIcono: TImageList;
    tmrIcono: TTimer;
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure imgIconoClick(Sender: TObject);
    procedure tmrIconoTimer(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end; 

var
  frmIcono: TfrmIcono;

implementation

uses mensaje,global;
var
    f_NumeroIcono:integer;

{ TfrmIcono }

procedure TfrmIcono.imgIconoClick(Sender: TObject);
    begin
        hide;
        g_tipo:=1;
        application.CreateForm(TfrmMensajes,frmmensajes);
        frmMensajes.ShowModal;
        close;
    end;

procedure TfrmIcono.tmrIconoTimer(Sender: TObject);
    begin
        if f_NumeroIcono = 0 then
            f_NumeroIcono:=1
        else
            f_NumeroIcono:=0;
        imlicono.GetBitmap(f_NumeroIcono,imgIcono.picture.Bitmap);

    end;

procedure TfrmIcono.FormClose(Sender: TObject; var CloseAction: TCloseAction);
    begin
         CloseAction:=cafree;
    end;

procedure TfrmIcono.FormCreate(Sender: TObject);
    begin
        left:=30;
        top:=50;
        imlicono.GetBitmap(0,imgIcono.picture.Bitmap);
    end;

initialization
  {$I icono.lrs}

end.

