unit mensaje;

{$mode objfpc}{$H+}

interface

uses
  unix,Classes, SysUtils, LResources, Forms, Controls, Graphics, Dialogs, ExtCtrls,
  StdCtrls;

type

  { TfrmMensajes }

  TfrmMensajes = class(TForm)
    btnAbrir: TButton;
    btnSalir: TButton;
    Image1: TImage;
    lblAviso: TLabel;
    lblmensaje: TLabel;
    tmrAceptar: TTimer;
    procedure btnAbrirClick(Sender: TObject);
    procedure btnSalirClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure FormShow(Sender: TObject);
    procedure tmrAceptarTimer(Sender: TObject);
  private
    procedure TipoVentana();
    { private declarations }
  public
    { public declarations }
  end;


var
  frmMensajes: TfrmMensajes;

implementation
uses global;
  var
   f_tiempo:integer;
{ TfrmMensajes }

procedure TfrmMensajes.FormShow(Sender: TObject);
    begin
        TipoVentana();
        setbounds(0,0,1024,768);
    end;

procedure TfrmMensajes.tmrAceptarTimer(Sender: TObject);
    begin
        f_tiempo:=f_tiempo+1;
        if f_tiempo>g_tiempo then
            begin
            btnsalir.enabled:=true;
            btnabrir.Enabled:=true;
            tmraceptar.Enabled:=false;
        end;
    end;

procedure TfrmMensajes.btnAbrirClick(Sender: TObject);
    var
        OrdenAbrirCarpeta:string;
    begin
        Hide;
        application.ProcessMessages;
        OrdenAbrirCarpeta:='nautilus ' + g_carpeta+' &';
        unix.fpSystem(OrdenAbrirCarpeta);
        close;
        application.Terminate;
    end;

procedure TfrmMensajes.btnSalirClick(Sender: TObject);
    begin
        close
    end;

procedure TfrmMensajes.FormClose(Sender: TObject; var CloseAction: TCloseAction
  );
    begin
        CloseAction:=cafree;
    end;

procedure TfrmMensajes.TipoVentana();
    var
        TamanoFuente,LongitudMensaje:integer;
    begin
        lblaviso.Caption:=g_titulo;
        case g_tipo of
            1:
                begin
                    btnsalir.Enabled:=true;
                    tmraceptar.Enabled:=false;
                    btnabrir.Enabled:=true;
                end;
            2:
                begin
                    btnsalir.Enabled:=false;
                    tmraceptar.Enabled:=true;
                    btnabrir.Enabled:=false;
                end
            else
                application.Terminate;
        end;
        LongitudMensaje:= length(g_mensaje);
        case LongitudMensaje of
            51..100:TamanoFuente:=18;
            26..50:TamanoFuente:=18;
            0..25:TamanoFuente:=18;
        else
            TamanoFuente:=18;
        end;
        lblmensaje.Font.Size:=TamanoFuente;
        lblmensaje.Caption:=g_mensaje;
        if g_archivo=0 then
            btnabrir.Visible:=false
        else
            btnabrir.Visible:=true;
    end;
initialization
  {$I mensaje.lrs}

end.

