{
  Aulalinex 3.0-7 Software de gestión de Aulas Tecnológicas
  Copyright (C) 2008-2009, Consejería de Educación,Junta de Extremadura
  Programación: Manuel Narváez Martínez  <mnarvaez007@gmail.com>
  Diseño gráfico: Ana María Zamora Moreno
  Desarrollado con Lazarus 0.9.26

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
}
unit acerca; 

{$mode objfpc}{$H+}

interface

uses
  inicio,Classes, SysUtils, LResources, Forms, Controls, Graphics, Dialogs, ExtCtrls,
  Buttons, StdCtrls;

type

  { TfrmAcerca }

  TfrmAcerca = class(TForm)
    btnLicencia: TBitBtn;
    btnVolver: TBitBtn;
    Image1: TImage;
    Memo1: TMemo;
    procedure btnLicenciaClick(Sender: TObject);
    procedure btnVolverClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: boolean);
    procedure FormCreate(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end; 

var
{ TfrmAcerca }
  frmAcerca: TfrmAcerca;

implementation
const
    COPYRIGHT:string='/usr/share/doc/aulalinex-profesor-ltsp/copyright';



procedure TfrmAcerca.FormCreate(Sender: TObject);
    begin
        top:=13;
        left:=(screen.Width-width) div 2;
        btnLicencia.Visible:=fileexists(COPYRIGHT)
    end;

procedure TfrmAcerca.btnLicenciaClick(Sender: TObject);
    begin
        if fileexists(COPYRIGHT) then
            begin
                memo1.lines.LoadFromFile(COPYRIGHT);
                memo1.Visible:=not memo1.Visible;
            end;
    end;

procedure TfrmAcerca.btnVolverClick(Sender: TObject);
    begin
        close;
    end;

procedure TfrmAcerca.FormActivate(Sender: TObject);
    begin
        if frmMain.Visible then frmMain.hide;
    end;

procedure TfrmAcerca.FormCloseQuery(Sender: TObject; var CanClose: boolean);
    begin
        frmMain.Show;
        hide;
    end;

initialization
  {$I acerca.lrs}

end.

