{
  Aulalinex 3.0-7 Software de gestión de Aulas Tecnológicas
  Copyright (C) 2008-2009, Consejería de Educación,Junta de Extremadura
  Programación: Manuel Narváez Martínez  <mnarvaez007@gmail.com>
  Diseño gráfico: Ana María Zamora Moreno
  Desarrollado con Lazarus 0.9.26

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
}
unit elegir; 

{$mode objfpc}{$H+}

interface

uses
  globales1,globales,textomensajes,Classes, SysUtils, LResources, Forms, Controls, Graphics, Dialogs, ExtCtrls,
  FileCtrl, EditBtn, StdCtrls;

type

  { TfrmElegir }

  TfrmElegir = class(TForm)
    btnAceptar: TButton;
    btnVolver: TButton;
    deDirectorio: TDirectoryEdit;
    flbArchivos: TFileListBox;
    Image1: TImage;
    procedure btnAceptarClick(Sender: TObject);
    procedure btnVolverClick(Sender: TObject);
    procedure deDirectorioAcceptDirectory(Sender: TObject; var Value: String);
    procedure deDirectorioChange(Sender: TObject);
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure FormCreate(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end; 

var
  frmElegir: TfrmElegir;

implementation

uses pantalla, dialogos;

{ TfrmElegir }

procedure TfrmElegir.deDirectorioAcceptDirectory(Sender: TObject;
  var Value: String);
    begin
        flbArchivos.Directory:=deDirectorio.Directory;
        flbArchivos.Refresh;
    end;

procedure TfrmElegir.deDirectorioChange(Sender: TObject);
    begin
        flbArchivos.Directory:=deDirectorio.Directory;
        flbArchivos.Refresh;
    end;

procedure TfrmElegir.FormClose(Sender: TObject; var CloseAction: TCloseAction);
    begin
        CloseAction:=cafree;
    end;

procedure TfrmElegir.FormCreate(Sender: TObject);
    begin
        top:=130;
        left:=(screen.Width-width) div 2;
        deDirectorio.Directory:=equipoProfesor.HomeProfesor;
        flbArchivos.Directory:=equipoProfesor.HomeProfesor;
    end;

procedure TfrmElegir.btnAceptarClick(Sender: TObject);
    begin
        if flbArchivos.Items.count<1 then
            mensaje(MEN_NO_ARCHIVOS,aceptar)
        else
            begin
                try
                    g_directorio_presentacion:=deDirectorio.Directory;
                    Ficheros.Assign(flbArchivos.items);
                    hide;
                    application.CreateForm(TfrmPresenta, frmpresenta);
                    frmpresenta.showModal;
                finally
                    close;
                end;
            end;
        end;

procedure TfrmElegir.btnVolverClick(Sender: TObject);
    begin
        close;
    end;

initialization
  {$I elegir.lrs}


end.

