{
  Aulalinex 3.0-7 Software de gestin de Aulas Tecnolgicas
  Copyright (C) 2008-2009, Consejera de Educacin,Junta de Extremadura
  Programacin: Manuel Narvez Martnez  <mnarvaez007@gmail.com>
  Diseo grfico: Ana Mara Zamora Moreno
  Desarrollado con Lazarus 0.9.26

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
}
unit globales;
{$mode objfpc}{$H+}
interface
uses unix,textomensajes, Classes,SysUtils,IniFiles,StrUtils,Graphics,Forms,Controls,Types;
    type
        TEstadoActividadEquipo=(eApagado,eEncendiendo,eEncendido,eUsuario,eApagando,eAveriado);
        EDialogos = (Aceptar,SiNo);
        TDialogo=Record
        mensaje:string;
        ClaseDialogo:Edialogos;
        respuesta:integer;
    end;

    const
         DIR_SETUP_AULALINEX:string='/var/lib/aulalinex-profesor-ltsp/setup.ini';
         ROJO_COLOR:Tcolor=$7B61FF;
         VERDE_COLOR:Tcolor=$66FFCC;
         BLANCO_COLOR:TColor=$E5E5E5;
         AZUL_COLOR:TColor=$FF6666;
         MORADO_COLOR:TColor=$CC0099;
         PUERTO_ROOT:INTEGER=36999;
         PUERTO_PRUEBAS:integer=37255;
    var
        g_webnavegar:string='';
        g_nombreAplicacion1:string='';
        g_mensaje_prioridad:string;
        g_mensaje_asunto:string;
        g_mensaje_texto:string;
        g_archivo_nombre:string;
        g_archivo_path:string;
        g_tipo_limpieza_archivos:string;
        g_carpeta_enviar_path:string;
        g_carpeta_devolver_nombre:string;
        g_carpeta_devolver_path:string;
        g_carpeta_recibir_path:string;
        g_directorio_presentacion:string;
        g_myl,g_myt:integer;
        g_MostrandoPantalla:integer=0;
        g_CanonTiempo:integer=20;
        g_CanonActivo:boolean=true;
        g_IniciadaSesion:boolean=false;
        g_PanelCanon:boolean=false;
        g_Display:string='0';
        g_apagando:boolean=false;
        g_NombreProfe:string;
        g_EspecialidaProfe:string;
        g_NombreAplicacion:array[0..8] of string;
        g_ComandoAplicacion:array[0..8] of string;
        g_AsignaProfe:array[0..7] of string;
        g_TipoClase:integer=0;
        g_DisenoClase:integer=0;
        g_num_diseno:integer=0;
        f_Posiciones:array[0..23] of Tpoint;
        g_num_ord_aula:integer;
        g_num_ord_pantalla:integer;
        g_numero_columnas:integer;
        g_aula:string;
        g_servidor:string;
        g_ipvlc:string='239.255.255.0';
        g_Internet_defecto:boolean=false;
        g_RatonTecladoDefecto:boolean=false;
        g_host_alumno:string;
        g_alumno:string;
        g_sepT:integer;
        g_EstoyPresentando:boolean=false;
        g_GrupoPertenece:boolean=false;
        g_NumCursos:integer=0;
        g_modoobservacion:integer;
        g_tipoobservacion:integer;
        g_contadorExamen:integer;
        g_examinando:Boolean=false;
        g_respuestas_recibidas:array of integer;
        g_tiempoRecogida:integer=5;
        Ficheros:TStringList;
        TipoDialogo:Tdialogo;
        Function Mensaje(texto:string;clase:edialogos):integer;
        Function NumeroNombreOrdenador(num:integer):string;
        Function HallarDatosUsuario(const S :string):string;
        Function HallarDato(Cmd:string):string;
        Function NumOrdLet(num:integer):string;
        Procedure LeerSetupProfe;
        procedure OrdenesAula(orden:string;comandos:array of const);
        function RGB(R, G, B: Byte): TColor;
        procedure CrearArchivos(NumRec:Integer;NomArchivo:string);
        Function QuitarAcentos(frase:string):string;
        Function CambiaCaracteres(frase:string):string;
        procedure LeerCoordenadas(var mx,my:integer;coor:string);
        procedure Ejecutar(cmd:string);
        procedure IniciarServidorVnc;
        procedure CerrarServidorVnc;
        procedure DimensionBMP( sArchivo: string; var wAncho, wAlto: Word );
        procedure DimensionJPG( sArchivo: string; var wAncho, wAlto: Word );
        procedure DimensionPNG( sArchivo: string; var wAncho, wAlto: Word );
        function LeerPalabraMotorola( F: TFileStream ): Word;
        procedure EscribirficheroCursos;
        function tiempo(value:integer):string;
        Function NombreMateria(NM:string):string;
        Function MateriaNombre(NM:string):string;
        Function LeerFicheroCursos():Boolean;
        function GetToken(Cadena:string; Separador:char; Token:integer):string;
implementation

uses globales1,dialogos;
{ TOrdenes }

procedure IniciarServidorVnc;
    const
        HALLARX11VNC:string='ps aux | grep 5899 | grep -v grep | grep -c x11vnc';
        ORD_INICIA_X11VNC:string='x11vnc -bg -localhost -shared -forever -nc 0 -rfbport 5899 -passwd %s -viewpasswd %s';
    var
        dato,orden:string;
    begin
        orden:=format(ORD_INICIA_X11VNC,[equipoProfesor.ContraVNCProfe,equipoProfesor.ContraVNCProfe]);
        dato:= Hallardato(HALLARX11VNC);
        if dato='0' THEN
                Ejecutar(orden);
    end;
procedure CerrarServidorVnc;
    const
        HALLARX11VNC:string='ps aux | grep 5899 | grep -v grep | grep -c x11vnc';
        ORD_FINALIZAR_X11VNC:string='killall -9 x11vnc';
    var
        dato,orden:string;
    begin
        dato:= Hallardato(HALLARX11VNC);
        if dato<>'0' THEN
           Ejecutar(ORD_FINALIZAR_X11VNC);
        sleep(100);
    end;

procedure Ejecutar(cmd:string);
    begin
       fpsystem(cmd);
    end;

function HallarDato(Cmd:string):String;
    var
        file1: TextFile;
        s,t: ansistring;
        n: longint;
        j:integer;
    begin
        j:=0;
        n:=popen(file1, Cmd, 'r');
        if n=-1 then
            begin
                result:='';
                Mensaje(MEN_ERROR_HALLAR_DATO,Aceptar);
                Exit;
            end;
        t:='';
        while not eof(file1) do begin
            Readln(File1,s);
            t:=t+s+Chr(10);
            inc(j);
        end;
        pclose(file1);
        result := trim(t);
    end;
    
function RGB(R, G, B: Byte): TColor;
    begin
        Result := TColor(R or (G shl 8) or (B shl 16));
    end;

procedure OrdenesAula(orden:string;comandos:array of const);
    var
        miorden:string;
    begin
        miorden:=format(orden,comandos);
        fpsystem(miorden)
    end;

Function NumOrdLet(num:integer):string;
    var
        letraord:string;
    begin
        num:=succ(num);
        letraord:=ifthen(num<10,'0'+inttostr(num),inttostr(num));
        result:=letraord;
    end;

Function NumeroNombreOrdenador(num:integer):string;
    begin
     result:=equipoalumno[num].IP;
    end;

Function Mensaje(texto:string;clase:edialogos):integer;
    begin
        tipodialogo.mensaje:=texto;;
        tipodialogo.clasedialogo:=clase;
        Tfrmdialogos.Create(nil).ShowModal;
        result:=tipodialogo.respuesta;
        frmdialogos.Free;
    end;

Procedure LeerSetupProfe;
    var
        MiFichero:TMeminiFile;
        i:integer;
    begin
        Mifichero:=TMeminifile.Create(equipoProfesor.ArcSetupProfe);
        with MIfichero do
            begin
                g_NombreProfe:=ReadString('Profesor','Nombre','');
                g_EspecialidaProfe:=ReadString('Profesor','Especialidad','Mi especialidad');
                for i:=0 to 8 do
                    begin
                        g_NombreAplicacion[i]:=ReadString ('Programas','Programa_'+inttostr(i),'');
                        g_ComandoAplicacion[i]:=ReadString ('Comandos','Comando_'+inttostr(i),'');
                    end;
                for i:= 0 to 7 do
                    g_asignaprofe[i]:=ReadString('Asignaturas','Asignatura_'+inttostr(i),'1ESO_ASI0'+inttostr(i+1));
                free;
            end;
    end;

Function HallarDatosUsuario(const S :string):string;
    begin
        result:=getenvironmentvariable(S);
    end;

procedure CrearArchivos(NumRec:Integer;NomArchivo:string);
    var
        Corriente:TResourceStream;
        NombreRecurso,NombreArchivo:string;
    begin
        if not fileexists(NomArchivo) then
            begin
                NombreArchivo:=NomArchivo;
                NombreRecurso:='#'+inttostr(NumRec);
                Corriente:=TResourceStream.Create( hInstance,NombreRecurso,RT_RCDATA );
                try
                    Corriente.Seek(0,soFromBeginning);
                    corriente.SaveToFile(NombreArchivo);
                finally
                    Corriente.Free;
                end;
            end;
    end;

Function QuitarAcentos(frase:string):string;
    var
        neofrase:string;
    begin
        neofrase:=frase;
        neofrase:=StringReplace(neofrase,' ','_',[rfReplaceAll]);
        neofrase:=StringReplace(neofrase,'/','_',[rfReplaceAll]);
        neofrase:=StringReplace(neofrase,'\','_',[rfReplaceAll]);
        neofrase:=StringReplace(neofrase,'','a',[rfReplaceAll]);
        neofrase:=StringReplace(neofrase,'','e',[rfReplaceAll]);
        neofrase:=StringReplace(neofrase,'','i',[rfReplaceAll]);
        neofrase:=StringReplace(neofrase,'','o',[rfReplaceAll]);
        neofrase:=StringReplace(neofrase,'','u',[rfReplaceAll]);
        neofrase:=StringReplace(neofrase,'','A',[rfReplaceAll]);
        neofrase:=StringReplace(neofrase,'','E',[rfReplaceAll]);
        neofrase:=StringReplace(neofrase,'','I',[rfReplaceAll]);
        neofrase:=StringReplace(neofrase,'','O',[rfReplaceAll]);
        neofrase:=StringReplace(neofrase,'','U',[rfReplaceAll]);
        neofrase:=StringReplace(neofrase,'','-',[rfReplaceAll]);
        neofrase:=StringReplace(neofrase,'','-',[rfReplaceAll]);
        neofrase:=StringReplace(neofrase,'','n',[rfReplaceAll]);
        neofrase:=StringReplace(neofrase,'?','-',[rfReplaceAll]);
        neofrase:=StringReplace(neofrase,'','-',[rfReplaceAll]);
        neofrase:=StringReplace(neofrase,'','-',[rfReplaceAll]);
        neofrase:=StringReplace(neofrase,'!','-',[rfReplaceAll]);
        neofrase:=StringReplace(neofrase,'(','-',[rfReplaceAll]);
        neofrase:=StringReplace(neofrase,')','-',[rfReplaceAll]);
        neofrase:=StringReplace(neofrase,'+','-',[rfReplaceAll]);
        neofrase:=StringReplace(neofrase,'*','-',[rfReplaceAll]);
        neofrase:=StringReplace(neofrase,'"','-',[rfReplaceAll]);
        neofrase:=StringReplace(neofrase,'=','-',[rfReplaceAll]);
        neofrase:=StringReplace(neofrase,'%','-',[rfReplaceAll]);
        result:=neofrase;
    end;

Function CambiaCaracteres(frase:string):string;
    var
        comando:string;
    begin
        comando:=frase;
        comando:=StringReplace(comando,'','á',[rfReplaceAll]);
        comando:=StringReplace(comando,'','é',[rfReplaceAll]);
        comando:=StringReplace(comando,'','i',[rfReplaceAll]);
        comando:=StringReplace(comando,'','ó',[rfReplaceAll]);
        comando:=StringReplace(comando,'','ú',[rfReplaceAll]);
        comando:=StringReplace(comando,'','A',[rfReplaceAll]);
        comando:=StringReplace(comando,'','º',[rfReplaceAll]);
        comando:=StringReplace(comando,'','ª',[rfReplaceAll]);
        comando:=StringReplace(comando,'','ñ',[rfReplaceAll]);
        comando:=StringReplace(comando,' ',' \ ',[rfReplaceAll]);
        result:=comando;
    end;

procedure LeerCoordenadas(var mx,my:integer;coor:string);
    var
        long,poscoma:integer;
        lx,ly:string;
    begin
        long:=length(coor);
        poscoma:=pos(',',coor);
        lx:=LeftStr(coor,poscoma-1);
        ly:=MidStr(coor,poscoma+1,long-poscoma);
        mx:=strtoint(lx);
        my:=strtoint(ly);
    end;
procedure DimensionBMP( sArchivo: string; var wAncho, wAlto: Word );
    var
        miImagen:Tbitmap;
    begin
        miImagen:=Tbitmap.create;
        try
            miImagen.LoadFromFile(sArchivo);
            wAncho:=miImagen.Width;
            wAlto:=miImagen.Height;
        finally
            miImagen.Free;
        end;
    end;

procedure DimensionJPG( sArchivo: string; var wAncho, wAlto: Word );
    const
        ValidSig: array[0..1] of Byte = ($FF, $D8);
        Parameterless = [$01, $D0, $D1, $D2, $D3, $D4, $D5, $D6, $D7];
    var
        Sig: array[0..1] of byte;
        F: TFileStream;
        x: integer;
        Seg: byte;
        Dummy: array[0..15] of byte;
        Len: word;
        iLongitudLinea: LongInt;
    begin
        FillChar( Sig, SizeOf( Sig ), #0 );
        F := TFileStream.Create( sArchivo, fmOpenRead );
        try
            iLongitudLinea := F.Read( Sig[0], SizeOf( Sig ) );
            for x := Low( Sig ) to High( Sig ) do
                if Sig[x] <> ValidSig[x] then
            iLongitudLinea := 0;
            if iLongitudLinea > 0 then
                begin
                  iLongitudLinea := F.Read( Seg, 1 );
                  while ( Seg = $FF ) and ( iLongitudLinea > 0 ) do
                  begin
                    iLongitudLinea := F.Read( Seg, 1 );
                    if Seg <> $FF then
                    begin
                      if ( Seg = $C0 ) or ( Seg = $C1 ) then
                          begin
                             iLongitudLinea := F.Read( Dummy[0], 3 );
                             wAlto := LeerPalabraMotorola( F );
                             wAncho := LeerPalabraMotorola( F );
                          end
                       else
                        begin
                           if not ( Seg in Parameterless ) then
                               begin
                                 Len := LeerPalabraMotorola( F );
                                 F.Seek( Len - 2, 1 );
                                 F.read( Seg, 1 );
                               end
                           else
                             Seg := $FF;
                        end;
                      end;
                   end;
                 end;
        finally
              F.Free;
        end;
    end;

procedure DimensionPNG( sArchivo: string; var wAncho, wAlto: Word );
    type
        TPNGSig = array[0..7] of Byte;
    const
        ValidSig: TPNGSig = (137,80,78,71,13,10,26,10);
    var
        Sig: TPNGSig;
        F: TFileStream;
        x: Integer;
    begin
        FillChar( Sig, SizeOf( Sig ), #0 );
        F := TFileStream.Create( sArchivo, fmOpenRead );
        try
            F.read( Sig[0], SizeOf( Sig ) );
            for x := Low( Sig ) to High( Sig ) do
            if Sig[x] <> ValidSig[x] then
             Exit;
            F.Seek( 18, 0 );
            wAncho := LeerPalabraMotorola( F );
            F.Seek( 22, 0 );
            wAlto := LeerPalabraMotorola( F );
        finally
            F.Free;
        end;
    end;

function LeerPalabraMotorola( F: TFileStream ): Word;
    type
        TPalabraMotorola = record
        case Byte of
            0: ( Value: Word );
            1: ( Byte1, Byte2: Byte );
        end;
    var
        MW: TPalabraMotorola;
    begin
        F.Read( MW.Byte2, SizeOf( Byte ) );
        F.Read( MW.Byte1, SizeOf( Byte ) );
        Result := MW.Value;
    end;

function GetToken(Cadena:string; Separador:char; Token:integer):string;
   var
        Posicion:integer;
   begin
      while Token > 1 do begin
        Delete(Cadena,1,Pos(Separador,Cadena));
        Dec(Token);
      end;
      Posicion:=Pos(Separador,Cadena);
      if Posicion=0
      then result:=cadena
      else Result:=Copy(Cadena,1,Posicion-Length(Separador));
   end;

procedure EscribirficheroCursos;
    var
        Mifichero:TMemIniFile;
        j,i:integer;
        cadenagrupo:string;
    begin
        try
           if FileExists(equipoProfesor.ArcCursos) then
              DeleteFile(equipoProfesor.ArcCursos);
          Mifichero := TMemIniFile.Create(equipoProfesor.ArcCursos);
             try
                with Mifichero do
                    begin
                        WriteInteger('Cursos','Numero_Cursos',g_NumCursos);
                        for i:=0 to high(g_Cursos) do
                             WriteString('Cursos','Curso_'+inttostr(i),g_Cursos[i].nombre);
                        for i:=0 to high(g_Cursos) do
                              begin
                                  WriteString('CURSO_'+inttostr(i),'Nombre',g_Cursos[i].nombre);
                                  WriteInteger('CURSO_'+inttostr(i),'Numero_Alumnos',g_Cursos[i].numeroAlumnos);
                                  WriteInteger('CURSO_'+inttostr(i),'Numero_Grupos',g_Cursos[i].numeroGrupos);
                                  for j:=0 to g_Cursos[i].numeroAlumnos-1 do
                                     WriteString('CURSO_'+inttostr(i),'Alumno_'+inttostr(j), g_Cursos[i].nombrealumnos[j]);
                                  if g_Cursos[i].numerogrupos>0 then
                                     for j:=0 to g_Cursos[i].numerogrupos-1 do
                                           WriteString('CURSO_'+inttostr(i),'nGrupo_'+inttostr(j),g_Cursos[i].nombregrupos[j]);
                                  cadenagrupo:='';
                                  for j:=0 to g_Cursos[i].numeroAlumnos-1 do
                                      begin
                                         cadenagrupo:=cadenagrupo+inttostr(g_Cursos[i].cgrupos[j]);
                                         if j<g_Cursos[i].numeroAlumnos-1 then
                                           cadenagrupo:=cadenagrupo+',';
                                      end;
                                       WriteString('CURSO_'+inttostr(i),'cGrupos',cadenagrupo);
                              end;
                         UpdateFile;
                    end;
              finally
                Mifichero.free;
            end;
        except
           //Mensaje(MEN_ERROR_GRUPOS,aceptar);
        end;
    end;
Function LeerFicheroCursos():Boolean;
    var
        Mifichero:TMemIniFile;
        migrupo,j,i:integer;
        posgrupo:string;
        numgru:integer;
    begin
        try
         result:=true;
         Mifichero := TMemIniFile.Create(equipoProfesor.ArcCursos);
            try
                with Mifichero do
                    begin
                        g_NumCursos:=ReadInteger('Cursos','Numero_Cursos',0);
                        if g_NumCursos=0 then
                            begin
                                result:=false;
                                exit;
                            end;
                        setlength(g_Cursos,g_NumCursos);
                        for i:=0 to high(g_Cursos) do
                              begin
                                  g_Cursos[i].nombre:=ReadString('CURSO_'+inttostr(i),'Nombre','');
                                  g_Cursos[i].numeroAlumnos:=ReadInteger('CURSO_'+inttostr(i),'Numero_Alumnos',1);
                                  setlength(g_Cursos[i].nombrealumnos,g_Cursos[i].numeroAlumnos);
                                  setlength(g_Cursos[i].cgrupos,g_Cursos[i].numeroAlumnos);
                                  for j:=0 to g_Cursos[i].numeroAlumnos-1 do
                                  g_Cursos[i].nombrealumnos[j]:=ReadString('CURSO_'+inttostr(i),'Alumno_'+inttostr(j),'');
                                  numgru:=ReadInteger('CURSO_'+inttostr(i),'Numero_Grupos',1);
                                  g_Cursos[i].numeroGrupos:=numgru ;
                                  setlength(g_Cursos[i].nombregrupos,g_Cursos[i].numerogrupos);
                                  for j:=0 to g_Cursos[i].numerogrupos-1 do
                                    g_Cursos[i].nombregrupos[j]:=ReadString('CURSO_'+inttostr(i),'nGrupo_'+inttostr(j),'nGrupo_'+inttostr(j));
                                  posgrupo:=ReadString('CURSO_'+inttostr(i),'cGrupos','0');
                                  for j:=0 to g_Cursos[i].numeroAlumnos-1 do
                                      begin
                                        migrupo:=strtoint(GetToken(posgrupo,',',j+1));
                                        g_Cursos[i].cgrupos[j]:=migrupo;
                                      end;

                              end;
                    end;
              finally
                Mifichero.free;
            end;
        except
           // Mensaje(MEN_ERROR_GRUPOS,aceptar);
        end;
    end;
function tiempo(value:integer):string;
    var
        minutos,segundos:string;
        nminutos,nsegundos:integer;
    begin
        nminutos:=value div 60;
        if nminutos<10 then
            minutos:='0'+inttostr(nminutos)
        else
            minutos:=inttostr(nminutos);
        nsegundos:=value mod 60;
        if nsegundos <10 then
            segundos:='0'+inttostr(nsegundos)
        else
            segundos:=inttostr(nsegundos);
        result:=minutos+':'+segundos;
    end;
Function NombreMateria(NM:string):string;
    var
    NotMat:string;
    begin
        if NM ='Ciencias Naturales' then
            notmat:='CIE'
        else if NM='Geografa e Historia' then
            notmat:='GEO'
        else if NM='Lengua' then
            notmat:='LEN'
        else if NM='Ingls' then
            notmat:='ING'
        else if NM='Francs' then
            notmat:='FRA'
        else if NM='Matemticas' then
            notmat:='MAT'
        else if NM='Tecnologa' then
            notmat:='TEC'
        else if NM='Msica' then
            notmat:='MUS'
        else if NM='Educacin Fsica' then
            notmat:='EDU'
        else if NM='tica' then
            notmat:='ETI'
        else if NM='Biologa y Geologa' then
            notmat:='BIO'
        else if NM='Dibujo' then
            notmat:='DIB'
        else if NM='Fsica y Qumica' then
            notmat:='FIS';
        result:=notmat;
    end;
Function MateriaNombre(NM:string):string;
    var
        NotMat:string;
    begin
        if NM ='CIE' then
            notmat:='Ciencias Naturales'
        else if NM='GEO' then
            notmat:='Geografa e Historia'
        else if NM='LEN' then
            notmat:='Lengua'
        else if NM='ING' then
            notmat:='Ingls'
        else if NM='FRA' then
            notmat:='Francs'
        else if NM='MAT' then
            notmat:='Matemticas'
        else if NM='TEC' then
            notmat:='Tecnologa'
        else if NM='MUS' then
            notmat:='Msica'
        else if NM='EDU' then
            notmat:='Educacin Fsica'
        else if NM='ETI' then
            notmat:='tica'
        else if NM='BIO' then
            notmat:='Biologa y Geologa'
        else if NM='DIB' then
            notmat:='Dibujo'
        else if NM='FIS' then
            notmat:='Fsica y Qumica'
          else if  NM='INF' then
              notmat:='Informtica';
        result:=notmat;
    end;

end.
