unit clrespuesta;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils,IdTCPClient;
type

  { ThrRespuesta }

  ThrRespuesta = class(TThread)
  private
    fhost,fcomando:string;
    fPuerto:integer;
 protected
        fcliente:TIdTcpClient;
        procedure Execute; override;
  public
       destructor Destroy; override;
       property Servidor: string read fhost write fhost;
       property Puerto: integer read fPuerto write fpuerto;
       property Comando: string read fcomando write fcomando;
  end;


implementation
destructor ThrRespuesta.Destroy;
    begin
        if fcliente<> nil then
            fcliente.free;
        inherited;
    end;
procedure ThrRespuesta.Execute;
    begin
        try
            fcliente:=TidTcpClient.create(nil);
            fcliente.Host:=fhost;
            fcliente.Port:=fpuerto;
            fcliente.ConnectTimeout:=15000;
            try
                if terminated then exit;
                fcliente.connect;
                try
                    fcliente.GetResponse(200);
                    fcliente.sendCmd(fcomando,261);
                finally
                    fcliente.Disconnect;
                end
            except
                 exit;
            end;
        except
              exit;
        end;
    end;

end.


