unit demonio ;

{$mode objfpc}{$H+}

interface 

uses 
  unix,clservidor,globales,Classes , SysUtils , FileUtil , LResources , Forms , Controls , Dialogs ,
  IdCmdTCPServer, IdCommandHandlers;

type 

  { TDataModule1 }

  TDataModule1 = class (TDataModule )
    IdCmdTCPServer1 : TIdCmdTCPServer ;
    procedure apagarEquipoCommand (ASender : TIdCommand );
    procedure hallarHostMacCommand(ASender: TIdCommand);
    procedure videoVLCCommand(ASender: TIdCommand);
    procedure videoVLCNoCommand(ASender: TIdCommand);
  private
    procedure Ejecutar1 (comando : string );
    { private declarations }
  public 
    { public declarations }
  end ; 

var 
  DataModule1 : TDataModule1 ; 

implementation 

{ TDataModule1 }

procedure TDataModule1.apagarEquipoCommand (ASender : TIdCommand );
    begin
        try
            miservidor.apagarEquipo;
            Asender.Reply.SetReply(302,'Apagando equipo');
            ASender.SendReply;
            if IdCmdTCPServer1.Active then IdCmdTCPServer1.Active:=false;
            Application.Terminate;
        except
           // writeln('Error al apagar equipo');
        end;
    end;
procedure TDataModule1.Ejecutar1 (comando:string);
    begin;
          unix.fpSystem(comando);
    end;
procedure TDataModule1.hallarHostMacCommand(ASender: TIdCommand);
    var
       hostmac:string;
    begin
        try
             hostmac:=miservidor.Host+'#'+miservidor.MAC;
             Asender.Reply.SetReply(308,hostmac);
             ASender.SendReply;
        except
             //writeln('Error al detectar el mac');
        end;
    end;

procedure TDataModule1.videoVLCCommand(ASender: TIdCommand);
    const
         ORD_ANADIR_IPVLC:String='/sbin/route add -net %s/24 gw %s &';
         ORD_VIDEO:String='su -c "DISPLAY=:7.0 vlc --video-on-top --skip-frames -f --no-audio udp:@%s" nobody &';
    var
        ipgw,ipvlc,miorden:string;
    begin
          try
          if ASender.Params.Count = 2  then
              begin
                 ipvlc:=ASender.Params[0];
                 ipgw:=ASender.Params[1];
                 miorden:=Format(ORD_ANADIR_IPVLC,[ipgw,ipvlc]);
                 Ejecutar1(miorden);
                 sleep(200);
                 miorden:=Format(ORD_VIDEO,[ipvlc]);
                 Ejecutar1(miorden);
                 end
          else
              begin
                 writeln('Numero de parámetros incorrectos')
              end;
          except
              writeln('Error al iniciar vlc')
          end;
    end;

procedure TDataModule1.videoVLCNoCommand(ASender: TIdCommand);
     const
          ORD_VLC_NO:string='killall -9 vlc';
     begin
        try
            Ejecutar1(ORD_VLC_NO);
        except
            writeln('Error al iniciar vlc')
        end;
    end;

initialization
  {$I demonio.lrs}
   miservidor:=Tservidor.create();
   DataModule1:=TDataModule1.create(nil);
Finalization
FreeAndNil(DataModule1);
FreeAndNil(miservidor);;

end .

