{
  Aulalinex 3.0-7 Software de gestión de Aulas Tecnológicas
  Copyright (C) 2008-2009, Consejería de Educación,Junta de Extremadura
  Programación: Manuel Narváez Martínez  <mnarvaez007@gmail.com>
  Diseño gráfico: Ana María Zamora Moreno
  Desarrollado con Lazarus 0.9.26

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
}
unit textomensajes;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils; 
const
 //Texto de los botones iniciar y dentener todos
    CAPTION_BOTONES_ACTIVOS:Array[0..13] of String = ('Encender todos','Ver todos', 'Mostrar a todos','Mensaje a todos','Archivo a todos','Recibir de todos','Lanzar todos','Navegar todos','Devolver todos','Carpeta todos','Video todos','Presentación','Desactivar todos','Inactivar todos');
    CAPTION_BOTONES_INACTIVOS:Array[0..13] of string=('Apagar todos','Cerrar todos', 'Ocultar a todos','Cerrar mensajes','Restaurar iconos','Restaurar iconos','Restaurar iconos','Restaurar iconos','Restaurar iconos','Restaurar iconos','Apagar todos','Fin presentación','Internet todos','Activar Todos');
    CAPTION_BOTONES_ACTIVOSG:Array[0..13] of String = ('Encender grupo','Ver grupo', 'Mostrar a grupo','Mensaje a grupo','Archivo a grupo','Recibir de todos','Lanzar a grupo','Navegar grupo','Devolver a grupo','Carpeta a grupo','Video grupo','Presentación','Desactivar grupo','Bloquear grupo');
    CAPTION_BOTONES_INACTIVOSg:Array[0..13] of string=('Apagar grupo','Cerrar grupo', 'Ocultar a grupo','Cerrar mensajes','Restaurar iconos','Restauras iconos','Restauras iconos','Cerrar grupo','Restaurar iconos','Restaurar iconos','Apagar grupo','Fin presentación','Internet grupo','Desbloquear grupo');
//Texto informativo sobre la pantalla activa
    NOMBRE_PANTALLA:Array[0..13] of string=('Encender/apagar ordenadores','Ver los ordenadores','Mostrar mi ordenador', 'Enviar un mensaje','Enviar un archivo','Recoger archivos','Iniciar una aplicación','Lanzar mozilla','Devuelve archivos a los alumnos','Enviar una carpeta','Mostrar un video','Realizar presentación','Desactivar internet', 'Bloquear/Desbloquear teclados y ratones');
//Curso ejemplo
    ALUMNOS_EJEMPLO:Array[0..23] of String = ('María-Eugenio', 'Emilia-Alfonso',
                'Manolo-Ana','Isabel-Carlos','María-Rosa','Juan Pablo-Pedro J.','Laura-Juan',
                'Amalia-Roberto','Enrique','Alberto-Javier','Luisa-Federico','Cristina-Teresa',
                'Rosa-Luis','Carlos-José','Mercedes','Zamora-Alfonso','Pilar-Casado','Nuria-Martín',
                'Ana-Luis','Vicente','Mariano','Adolfo-Teodora','Pilar-Casado','Pichurri');
//Mensajes
    MEN_ALUMNOS_APAGAR:string='¿Deseas apagar también los equipos de los alumnos?';
    MEN_ARCHIVOS_RECIBIDOS:string='Archivo';
    MEN_ARCHIVOS_RECOGIDOS:string='Tus archivos han sido enviados al profesor';
    MEN_AULA_NO_CONFIFURADA:string='Esta aula no está configurada';
    MEN_AULA_NO_CONFIGURADA:STRING='El aula no ha sido configurada correctamente. Ejecute la tarea configurar_aula.sh en el servidor o encienda los equipos de los alumnos y configúrela manulamente. (menú configurar->adminstrador)';
    MEN_AYUDA_NO__INSTALADA:string='El paquete aulalinex-ayuda no está instalado';
    MEN_CARPETA_ENVIAR:string='¿Desea enviar la carpeta ';
    MEN_CARPETA_RECIBIDA:string='Carpeta';
    MEN_COLOCAR_EQUIPOS:string='Debes colocar todos los equipos';
    MEN_CONTINUAR:string=' ¿Desea continuar?';
    MEN_CONTRA_ADMINISTRADOR:string='Necesita la contraseña del administrador. ¿Desea continuar?';
    MEN_CONTRA_INCORRECTA:string='La contraseña no es correcta';
    MEN_DESEA_APAGARLAS:string=' ¿Desea apagarlos?';
    MEN_ELIGE_ASIGNATURA:string='Selecciona una asignatura';
    MEN_ELIGE_CURSO:string='Selecciona un curso';
    MEN_ELIGE_DIRECTORIO:string='Selecciona una directorio válido';
    MEN_ELIGE_NIVEL:string='Indica el Nivel del grupo';
    MEN_ELIGE_NOMBRE:string='Debes indicar un nombre para este grupo';
    MEN_ELIGE_NUM_ORD:string='selecciona el número de ordenadores de aula';
    MEN_ELIGE_VIDEO:string='Selecciona un archivo de video';
    MEN_ELIG_GRUPO:string='Indica un grupo';
    MEN_ELIMINAR_ENVIADOS:string='¿Desea eliminar de los equipos de los alumnos los archivos que les ha enviado?';
    MEN_ELIMINAR_ENVREC:string='¿Desea eliminar de los equipos de los alumnos los archivos recibidos y enviados?';
    MEN_ELIMINAR_RECIBIDOS:string='¿Desea eliminar de los equipos de los alumnos, los archivos que ya les ha recogido?';
    MEN_ENCUESTA_ACTIVA:string='Hay una encuesta activa.Se perderá. ¿Desea salir?';
    MEN_ERROR_ARCHIVO:string='El archivo tiene un formato no válido o no tiene permisos suficientes';
    MEN_ERROR_AULA:string='Error al cargar el archivo de configuración /var/lib/aulalinex-profesor-ltsp/setup.ini';
    MEN_ERROR_CAPTURA:string='Error en la captura. Revise el directorio .aulalinex o su quota';
    MEN_ERROR_COPIA_CARPETA:string='No se puede copiar esta carpeta';
    MEN_ERROR_DETECTAR:string='Error al conectar con los alumnos';
    MEN_ERROR_ENVIAR_COMANDO:STRING='Error al enviar el comando';
    MEN_ERROR_GRUPOS:string='Error al cargar grupos, si el problema persiste elimine el archivo.cursos.ini de la carpeta .aulalinex de su directorio personal';
    MEN_ERROR_GUARDAR_CUESTION:string='Error al guardar la cuestión';
    MEN_ERROR_HALLAR_DATO:STRING='Error al hallar dato';
    MEN_ERROR_INICIAR_SERVIDOR:string='Error al iniciar servidor';
    MEN_ERROR_LEER_CUESTION:string='Error al leer cuestión';
    MEN_ERROR_LEER_CUETION:string='Error al leer la cuestion';
    MEN_ERROR_MENSAJE:string='Error al generar un mensaje';
    MEN_ERROR_MOSTRAR:string='Error al mostrar archivo. Compruebe los permisos de archivos y carpetas';
    MEN_ERROR_NO_INSTALADO:string='El usuario aulalinex-profesor no existe. Vuelva a instalar la aplicación';
    MEN_ESCRIBE_MENSAJE:string='Escribe un mensaje';
    MEN_ESTADO:string='Comprobando encendido de los ordenadores de los alumnos. La duración de este proceso dependerá del estado de los mismos. Espere un momento, por favor.';
    MEN_EXAMEN_NO_ENVIADO:string='No se ha podido enviar el examen. Compruebe que la carpeta aulalinex_consultas existe y que tiene permisos adecuados';
    MEN_GUARDAR_CAMBIOS:string='¿Desea guardar los cambios realizados?';
    MEN_GUARDAR_FAVORITOS:string='¿Desea guardar los cambios realizados en sus páginas favoritas?';
    MEN_GUARDAR:string='¿Desea guardar los cambios realizados?';
    MEN_INDICA_IP_PROFESOR:string='Indica la IP o el nombre de la mesa del profesor';
    MEN_INDICA_NUM_ORD:string='Indica el número de ordenadores del aula';
    MEN_INICIAR_VIDEO:string='Pulse iniciar para comenzar la proyección';
    MEN_IP_GATEWAY:string='Indica la IP del Gateway';
    MEN_IPS_ALUMNOS:string='Tienes que indicar un nombre o IP para todos los ordenadores';
    MEN_IPS_INVISBLES:string='Haz clic sobre el boton diseñar o selecciona la opción diseño automático';
    MEN_IP_VLC:string='La IP para emitir vlc tiene que ser similar a 239.255.XXX.0';
    MEN_LIMPIAR_CAPTURAS:string='Esto eliminará todas las capturas guardadas. ¿Desea Continuar?';
    MEN_LIMPIAR_DEVUELTOS:string='Esto eliminará todos los archivos de su carpeta ';
    MEN_MESAS_ENCENDIDAS:string='Están encendidos los siguientes equipos: ';
    MEN_MESAS_NO_ENCENDIDAS:string='¡Atención! Las siguientes equipos no están encendidos: ';
    MEN_NO_ARCHIVOS:string='En esta carpeta no hay ningún archivo';
    MEN_NO_CONSULTAS:string='No hay consultas disponibles. Cree una desde la pantalla cuestiones';
    MEN_NO_ENCENDIDOS:string='En este momento no hay ningún alumno logueado. Por favor, encienda los ordenadores o compruebe su estado pulsando revisar encendidos';
    MEN_NO_ENVIAR_CUESTION:string='No se ha podido enviar la cuestión. Compruebe que la carpeta aulalinex_consultas existe y que tiene permisos adecuados';
    MEN_NO_EXISTE_ARCHIVO:string='No existe el archivo elegido. Comprueba el nombre';
    MEN_NO_EXISTE_CONSULTA:STRING='No existe esa consulta';
    MEN_NOMBRE_CUESTION:string='Indica un nombre para esta cuestión.';
    MEN_NO_MESAS_ENCENDIDAS:string='No hay ninguna mesa encendida en el aula';
    MEN_NO_PERMISOS:string='No tiene permiso para ver esta carpeta';
    MEN_NO_PERMISO:string='Sólo el root pueden configurar el aula';
    MEN_NO_USUARIO:string='En este momento, no aparece ningún usuario trabajando en este equipo';
    MEN_NUEVO_CUESTION:string='¿Desea realizar una nuevo cuestion?';
    MEN_NUEVO_EXAMEN:string='¿Desea realizar un nuevo examen?';
    MEN_NUMERO_FILAS:string='Selecciona el número de filas del aula';
    MEN_NUMERO_ORDENADORES:string='Elige el número de ordenadores';
    MEN_OPCIONES_CUESTION:string='Completa todas las opciones.';
    MEN_ORDENADORES_ENCENDIDOS:string='Es muy importante que todos los ordenadores de la clase estén encendidos y con el nombre correcto.¿Desea continuar?';
    MEN_ORDEN_NUM_INCORRECTOS:string='orden o número de parámetros incorrecto';
    MEN_ORG_RESULTADOS:string='Organizando resultados, espere unos segundos, por favor.';
    MEN_PREGUNTA_CUESTION:string='Indica una pregunta.';
    MEN_PRESENTACION_ALUMNO:string='Solo puede realizar la presentación un alumno';
    MEN_PROFE_APAGAR:string='¿Deseas desconectar su ordenador?';
    MEN_RECOGIENDO_RESPUESTAS:string='Recogiendo respuestas. Espere, por favor';
    MEN_REFRESCAR:string='Esto revisará los usuarios de los alumnos. La duración de este proceso dependerá del estado de los equipos. ¿Desea continuar?';
    MEN_RETIRAR_MONITORES:string='¿Deseas retirar los monitores del area de diseño?';
    MEN_SALIR_ADMIN:string='¿Deseas salir del Administrador?';
    MEN_SALIR_PRESENTA:string='¿Desea salir de la presentación?';
    MEN_SALIR:string='¿Desea salir del programa?';
    MEN_SALIR_ZONA:string='¿Desea abandonar esta zona?';
    MEN_SELECCIONA_CUESTION:string='Selecciona una cuestión';
    MEN_SELECCIONE_CURSO:string='Seleccione en la lista el curso que desea modificar';
    MEN_SELECIONE_VIDEO:string='Seleccione una archivo de vídeo';
    MEN_SOLO_PROFES:string='Sólo los miembros del grupo profesor, el root y aulalinex-profesor pueden usar este programa, Consulta con tu administrador';
    MEN_SOLUCION_CUESTION:string='Indica una solucion para la cuestión.';
    MEN_TIEMPO_EXAMEN_FIN:string='El tiempo de examen ha finalizado. Haz clic sobre el icono o sobre el reloj para ver los resultados';
    MEN_USUARIOSNH:string='Esto detendrá la comprobación de usuarios alumnos ¿Desea continuar?';
    MEN_USUARIOSRV:string='Pulse antes en "Revisar encendidos" para hallar los usuarios de los equipos de los alumnos';
    MEN_USUARIOS:string='Hallando el nombre de los usuarios de los equipos de los alumnos. Espere un momento, por favor.';
    MEN_MAC_HALLADAS:string='Las MACs de los equipos de los alumnos han sido obtenidas correctamente';
    MEN_ERROR_HALLAR_MAC:string='Error al hallar las MACs';
    MEN_ERROR_GUARDAR_AULA:string='Error al guardar datos, compruebe los permisos y el propietario del archivo /var/lib/aulalinex-profesor-ltsp/setup.ini';
    MEN_SELECCIONE_GRUPO:string='Seleccione en la lista grupos el grupo desea eliminar';
    MEN_GRUPO_MODIFICAR:string='Seleccione en la lista grupos el que desea modificar';
    MEN_GRUPO_MODIFICADO:string='El grupo ha sido modificado';
    MEN_INDICA_NOMBRE:string='Indica un nombre para este grupo';
    MEN_INDICA_AULA:string='Elige en la lista cursos el aula en la que quieres crear los grupos';
    MEN_SELECCIONA_EQUIPO:string='Tienes que seleccionar al menor un ordenador por cada grupo';
    MEN_GRUPO_EXISTE:string='Ya existe un grupo en este curso con ese nombre';
    MEN_EXAMEN_ABANDONAR:STRING='Si abandona esta pantalla cerrará el examen en curso. ¿Desea continuar?';
    MEN_CALCULANDO_RESULTADOS:string='Calculando resultados. Espere unos segundos, por favor.';
    MEN_NOMBRE_EXAMEN:string='Indica un nombre para este examen';
    MEN_COMPLETA_SOLUCIONES:string='Completa todas las soluciones';
    MEN_COMPLETA_OPCIONES:string='Completa todas las opciones';
    MEN_COMPLETA_PREGUNTAS:string='Completa todas las preguntas';
    MEN_SELECIONA_CURASI:string='Selecciona curso, evaluación y asignatura';
    MEN_ERROR_ENVIAR_EXAMEN:string='No se ha podido enviar el examen. Compruebe que la carpeta aulalinex_consultas existe y que tiene permisos adecuados';
    MEN_ERROR_CREAR_EXAMEN:string='Error al crear examen';
    MEN_TERMINAR_EXAMEN:string='Aún queda %s alumnos sin entregar. Sus respuestas no serán recogidas ¿Desea finalizar este examen?';
implementation

end.

